#ifndef CGEN_H
#define CGEN_H

/*
	String streams are handy for using standard C-library
	functions to produce formatted strings.
*/
typedef struct sstream
{
	char *buffer;
	size_t bufsize;
	FILE* stream;
} sstream;

void ssopen(sstream* S);
char* ssvalue(sstream* S);
void ssclose(sstream* S);

#define ARRAY 1
#define NOT_ARRAY 0

/*
 	This function takes the same arguments as printf,
 	but returns a new string with the output value in it.
 */
char* template(const char* pat, ...);


/*
	This is the function used to report errors in the translation.
*/
void yyerror(char const* pat, ...);

/*
	This is set to the number of calls to yyerror
 */
extern int yyerror_count;


/* This is output at the head of a c program. */
extern const char* c_prologue;

/*
 Make a C string literal out of a PTUC string literal.
 Return the corrected string (maybe the same as P).
*/
char* string_ptuc2c(char* P);


//pernei eisodo string typou x,y,z kai ta kanei data_type x,data_type y klp
char *mult_args(char *data_type,char *args,char *brackets,int isArray);

/*kanei concat 2 string*/
char *concat2(char *str1,char *str2);

/*metraei '['*/
int count_brackets(char *input);

#endif