/*Onoma: Georgios Vougioukas
*	 AM: 2011030011
*/

%{
	#include <stdio.h>
	#include <string.h>
	#include "hashtable.h"
	#include "pars.tab.h"

	HashTable table;
	int eq(const void *str1,const void *str2);
	size_t hash_func(const void *str);
	void insert_macro(char *identifier, char *value);
	char *get_string(char *identifier);
	void proc_macro(char *macro,char *val);

	void h_init();
	extern int yyerror_count;
	extern void yyerror (char const *pat, ...);

	char *deftmp;
	#define M 100 //megistos arithmos defmacro
	
%}
/*petaei thn grammh p exei sfalma*/
%option yylineno

/*sinthikes gia ta defmacro kai ta multi line comments*/
%x defmacro
%x mlcomment


/*identifier (onoma metavlhths px) */
identifier [A-Za-z][A-Za-z0-9_]*

/*akeraies thetikes statheres*/
int_const  [0-9][0-9]*

/*pragmatikes thetikes statheres, me proeretiko ektheth, xwris perita mhdenika sthn arxh*/
real_const ("."{int_const})|({int_const}("."{int_const}?)?)([E|e][+|-]?{int_const})?

/*string p ksekinane me mona aytakia*/
string_constant ['][^'\n]*[']

/*...string me mona*/
string_constant2 ["][^'\n]*["]

/*sxolia grammhs*/
line_comment "//".*


white [ \r\t]*

%%
"and" {printf("//token KEYWORD_AND %s\n",yytext);return (KW_AND);}
"div" {printf("//token KEYWORD_DIV %s\n",yytext);return (KW_DIV);}
"function" {printf("//token KEYWORD_FUNCTION %s\n",yytext);return (KW_FUNCTION);}
"mod" {printf("//token KEYWORD_MOD %s\n",yytext);return (KW_MOD);}
"procedure" {printf("//token KEYWORD_PROCEDURE %s\n",yytext);return (KW_PROC);}
"result" {printf("//token KEYWORD_RESULT %s\n",yytext);return (KW_RES);}


"array" {printf("//token KEYWORD_ARRAY %s\n",yytext);return (KW_ARRAY);}
"do" {printf("//token KEYWORD_DO %s\n",yytext);return (KW_DO);}
"goto" {printf("//token KEYWORD_GOTO %s\n",yytext);return (KW_GOTO);}
"not" {printf("//token KEYWORD_NOT %s\n",yytext);return (KW_NOT);}
"program" {printf("//token KEYWORD_PROGRAM %s\n",yytext);return (KW_PROGRAM);}
"return" {printf("//token KEYWORD_RETURN %s\n",yytext);return (KW_RETURN);}

"boolean" {printf("//token KEYWORD_BOOLEAN %s\n",yytext);return (KW_BOOL);}
"else" {printf("//token KEYWORD_ELSE %s\n",yytext);return (KW_ELSE);}
"if" {printf("//token KEYWORD_IF %s\n",yytext);return (KW_IF);}
"of" {printf("//token KEYWORD_OF %s\n",yytext);return (KW_OF);}
"real" {printf("//token KEYWORD_REAL %s\n",yytext);return (KW_REAL);}
"then" {printf("//token KEYWORD_THEN %s\n",yytext);return (KW_THEN);}


"char" {printf("//token KEYWORD_CHAR %s\n",yytext);return (KW_CHAR);}
"for" {printf("//token KEYWORD_FOR %s\n",yytext);return (KW_FOR);}
"integer" {printf("//token KEYWORD_INTEGER %s\n",yytext);return (KW_INT);}
"or" {printf("//token KEYWORD_OR %s\n",yytext);return (KW_OR);}
"repeat" {printf("//token KEYWORD_REPEAT %s\n",yytext);return (KW_REPEAT);}
"until" {printf("//token KEYWORD_UNTIL %s\n",yytext);return (KW_UNTIL);}


"begin" {printf("//token KEYWORD_BEGIN %s\n",yytext);return (KW_BEGIN);}
"end" {printf("//token KEYWORD_END %s\n",yytext);return (KW_END);}
"var" {printf("//token KEYWORD_VAR %s\n",yytext);return (KW_VAR);}
"while" {printf("//token KEYWORD_WHILE %s\n",yytext);return (KW_WHILE);}
"to" {printf("//token KEYWORD_TO %s\n",yytext);return (KW_TO);}
"downto" {printf("//token KEYWORD_DOWNTO %s\n",yytext);return (KW_DOWNTO);}

"type" {printf("//token KEYWORD_TYPE %s\n",yytext);return (KW_TYPE);}


"+" 	{printf("//token OP_PLUS %s\n",yytext);return (OP_PLUS);}
"-" 	{printf("//token OP_MINUS %s\n",yytext);return (OP_MINUS);}
"*" 	{printf("//token OP_MULT %s\n",yytext);return (OP_MULT);}
"/" 	{printf("//token OP_DIVD %s\n",yytext);return (OP_DIVD);}


"=" 	{printf("//token OP_EQ %s\n",yytext);return (OP_EQ);}
"<>" 	{printf("//token OP_UNEQ %s\n",yytext);return (OP_UNEQ);}


"<" 	{printf("//token OP_LESS %s\n",yytext);return (OP_LESS);}
"<=" 	{printf("//token OP_LEQ %s\n",yytext);return (OP_LEQ);}
">" 	{printf("//token OP_GREAT %s\n",yytext);return (OP_GREAT);}
">="	{printf("//token OP_GEQ %s\n",yytext);return (OP_GEQ);}


"&&" 	{printf("//token OP_AND %s\n",yytext);return (KW_AND);}
"||" 	{printf("//token OP_OR %s\n",yytext);return (KW_OR);}
"!" 	{printf("//token OP_NOT %s\n",yytext);return (KW_NOT);}

":="	{printf("//token OP_ASSIGNMENT %s\n",yytext);return (OP_ASSIGN);}

";"		{printf("//token SEMICOLON %s\n",yytext);return (SEMICOLON);}

"("		{printf("//token LEFT_PARENTHESIS %s\n",yytext);return (LEFT_PARENTHESIS);}
")"		{printf("//token RIGHT_PARENTHESIS %s\n",yytext);return (RIGHT_PARENTHESIS);}
"["		{printf("//token LEFT_BRACKET %s\n",yytext);return (LEFT_BRACKET);}
"]"		{printf("//token RIGHT_BRACKET %s\n",yytext);return (RIGHT_BRACKET);}

","		{printf("//token COMA %s\n",yytext);return (COMA);}
"."		{printf("//token DOT %s\n",yytext);return (DOT);}
":"		{printf("//token ANW_KATW %s\n",yytext);return (COL);}


true 	{printf("//token BOOLCONST_TRUE %s\n",yytext);return (BTRUE);}
false	{printf("//token BOOLCONST_FALSE %s\n",yytext);return (BFALSE);}



{identifier} 		{	
						/*an erthei identifier elegxw an aftos o identifier
						*yparxei sto hashtable an nai tote einai dhlwmenos
						*me defmacro opote dinw ston flex na kanei analyse 
						*tn akolouthia p syntomevei o identifier sto macro 
						*(me to loopaki sto else k to unput, kathws me yypop_buffer klp
						*kati dn ekana kala k dn douleve), an oxi tote apla ton krataw opws einai
						*/
						
						char *tmp=get_string(strdup(yytext));
						
						if (tmp==NULL)
						{
							printf("//token IDENTIFIER %s\n",yytext);
							yylval.crepr = strdup(yytext);	//epistrefw ton identifier ayton kath'ayton
						   	return (IDENT);
						}
						else
						{
							
							int i=0;
							for (i=strlen(tmp);i>0;i--){
								unput(tmp[i-1]); //dinw ston flex na kanei analyse to string p exei to macro
							}
						}		
					}


{int_const}	 		{printf("//token INTEGER %s\n",yytext);yylval.crepr = strdup(yytext);return (POSINT);} //me thn yylval, epistrefw thn timh
{real_const} 		{printf("//token REAL %s\n",yytext);yylval.crepr = strdup(yytext);return (REAL);}	   //pou anagnwrise o flex oxi apla "ti"
{string_constant}	{printf("//token STRING %s\n",yytext);yylval.crepr = strdup(yytext);return (STRING);}  //anagnorise
{string_constant2}	{printf("//token STRING %s\n",yytext);yylval.crepr = strdup(yytext);return (STRING);}


"@defmacro"[ \r\t]+{identifier}		{	
										BEGIN(defmacro);
										deftmp=strdup(yytext); //vazw ta periexomena tou macro sthn (global) deftmp
									}
<defmacro>.*						{proc_macro(deftmp,strdup(yytext));BEGIN(INITIAL);}	//... kai to kanw process me thn proc_macro




{white}			{}
\n 				{}

"(*"				BEGIN(mlcomment);	/*opws dothike sto voithitiko arxeio (k opws fainetai sto faq tou flex)*/
<mlcomment>[^*\n]*						
<mlcomment>"*"+[^*)\n]*
<mlcomment>"*)"		BEGIN(INITIAL);      //an ftasei edw exei diavasei comment no problem
<mlcomment>\n
<mlcomment><<EOF>>	{yyerror("Error %s at line %d: Unterminated comment\n",yytext,yylineno);BEGIN(INITIAL);yyerror_count=1;}


{line_comment}  {}
<<EOF>> 			return (EOF);
.			  		{yyerror("Error %s at line: %d\n",strdup(yytext),yylineno);yyerror_count=1;}

%%


/*copy-paste apo leitourgika*/

/*h equal pou xreiazetai o hash table gia tin isothta (exw string ara kanw mia aplh strcmp*/
int eq(const void *str1,const void *str2)
{
	return strcmp((char*)str1,(char*)str2)==0;
}

/*to hash function (strhash gia string)*/
size_t hash_func(const void *str)
{
	return strhash((char *)str);
}

void h_init()
{
	HashTable_init(&table,M,hash_func,eq);
}

/*eisagei defmacro pair sto hash table*/
void insert_macro(char *identifier, char *value)
{
	HashTable_insert(&table,(char*)identifier,(char*)value);//kanw insert
}

/*epistrefei to string p orizetai apo to ident mesw tou defmacro, aliws null*/
char *get_string(char *identifier)
{
	return (char*)HashTable_get(&table,(char*)identifier,NULL); //..aliws null
}

/*eisagei ident-macro pair sto hash table*/
void proc_macro(char *macro,char *val)
{
	//char *tmp;
	char *ident;
	strtok(macro," ");
	ident=strtok(NULL," ");

	insert_macro(ident,val);
}